package com.zx.dataservice.utils;


import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;

/**
 * bigdcimal工具类
 *2020-12-16
 * @author qlm
 */
public class BigdecimalUtil {


    /**
     * 提供2个字符串的加减乘除
     * @param str  1
     * @param str2 2
     * @param type +-
     * @param i 精度
     * @param ii 几位
     * @return
     */
    public static String getNew(String str,String str2,String type,int i,int ii) {
        BigDecimal bigDecimal  = new BigDecimal(0);
        if("*".equals(type)){
            bigDecimal = new BigDecimal(str).multiply(new BigDecimal(str2)).setScale(i, ii);
        }else if("/".equals(type)){
            if(!"0".equals(str2)){
                bigDecimal = new BigDecimal(str).divide(new BigDecimal(str2),i,ii);
            }
        }else if("+".equals(type)){
            bigDecimal = new BigDecimal(str).add(new BigDecimal(str2)).setScale(i, ii);
        }else if("-".equals(type)){
            bigDecimal = new BigDecimal(str).subtract(new BigDecimal(str2)).setScale(i, ii);
        }
        return bigDecimal.toString();
    }

    public static String getNew(String str,String str2,String type,int i,int ii,String mul) {
        BigDecimal bigDecimal  = new BigDecimal(0);
        if(StringUtils.isBlank(mul)){
            if("*".equals(type)){
                bigDecimal = new BigDecimal(str).multiply(new BigDecimal(str2)).setScale(i, ii);
            }else if("/".equals(type)){
                if(!"0".equals(str2)){
                    bigDecimal = new BigDecimal(str).divide(new BigDecimal(str2),i,ii);
                }
            }else if("+".equals(type)){
                bigDecimal = new BigDecimal(str).add(new BigDecimal(str2)).setScale(i, ii);
            }else if("-".equals(type)){
                bigDecimal = new BigDecimal(str).subtract(new BigDecimal(str2)).setScale(i, ii);
            }
        }else {
            if("*".equals(type)){
                bigDecimal = (new BigDecimal(str).multiply(new BigDecimal(mul))).multiply(new BigDecimal(str2)).setScale(i, ii);
            }else if("/".equals(type)){
                if(!"0".equals(str2)){
                    bigDecimal = (new BigDecimal(str).multiply(new BigDecimal(mul))).divide(new BigDecimal(str2),i,ii);
                }
            }else if("+".equals(type)){
                bigDecimal = (new BigDecimal(str).multiply(new BigDecimal(mul))).add(new BigDecimal(str2)).setScale(i, ii);
            }else if("-".equals(type)){
                bigDecimal = (new BigDecimal(str).multiply(new BigDecimal(mul))).subtract(new BigDecimal(str2)).setScale(i, ii);
            }
        }

        return bigDecimal.toString();
    }

    /**
     * 比较2个数字的大小
     * 大于或等于 返回 true
     */
    public static boolean compare(String str,String str2) {
        BigDecimal a = new BigDecimal (str);
        BigDecimal b = new BigDecimal (str2);
        boolean f = false ;
        if(a.compareTo(b) == -1){
            f =  false;
        }
        if(a.compareTo(b) == 0){
            f =  true;
        }
        if(a.compareTo(b) == 1){
            f =  true;
        }
        return f;

    }

}
